# nomad-pilot-cli
This is the API descriptor for the Nomad Pilot API, responsible for shipping and logistics processing.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 0.1.2
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import nomad_pilot_cli 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import nomad_pilot_cli
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import nomad_pilot_cli
from nomad_pilot_cli.rest import ApiException
from pprint import pprint

# Configure API key authorization: APIKeyHeader
configuration = nomad_pilot_cli.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = nomad_pilot_cli.ShipApi(nomad_pilot_cli.ApiClient(configuration))
carrier = 'carrier_example' # str | String name of carrier
order_ref = 'order_ref_example' # str | String name of order ref (by Odoo)
body = nomad_pilot_cli.Package() # Package |  (optional)

try:
    # Attempt to cancel a created waybill
    api_response = api_instance.cancel_ship(carrier, order_ref, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ShipApi->cancel_ship: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://pilot.samarkand.io/pilot*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ShipApi* | [**cancel_ship**](docs/ShipApi.md#cancel_ship) | **DELETE** /ship/{carrier}/order/{order_ref} | Attempt to cancel a created waybill
*ShipApi* | [**ship**](docs/ShipApi.md#ship) | **POST** /ship/{carrier} | Create a new waybill


## Documentation For Models

 - [Address](docs/Address.md)
 - [ApiResponse](docs/ApiResponse.md)
 - [ApiResponseConnectorResponse](docs/ApiResponseConnectorResponse.md)
 - [ApiResponseData](docs/ApiResponseData.md)
 - [Package](docs/Package.md)
 - [PackageDimension](docs/PackageDimension.md)
 - [PackageGoldjet](docs/PackageGoldjet.md)
 - [PackageItems](docs/PackageItems.md)


## Documentation For Authorization


## APIKeyHeader

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author

paul@samarkand.global

